"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SELECTED = exports.ON_HOVER = exports.SELECTOR_ACTIVE = void 0;
// @ts-nocheck
const react_1 = __importStar(require("react"));
const useCapture = true;
exports.SELECTOR_ACTIVE = "self-service-editable-active";
exports.ON_HOVER = "self-service-editable-hover";
exports.SELECTED = "self-service-editable-seleted";
const shouldIgnoreElement = (ignoreElement, elementRef, target) => {
    if (elementRef && elementRef.current) {
        return elementRef.current.contains(target) === false;
    }
    if (ignoreElement) {
        return ignoreElement.contains(target) === false;
    }
    return false;
};
const cleanupSelected = () => {
    const selected = document.querySelector(`.${exports.SELECTED}`);
    if (selected)
        selected.classList.remove(exports.SELECTED);
    const hover = document.querySelector(`.${exports.ON_HOVER}`);
    if (hover)
        hover.classList.remove(exports.ON_HOVER);
};
const Highlight = ({ ignoreElement, isActiveRef, selectedElement, onSelect, onlySelect, children, tagName, selectRootComponent }) => {
    const elementRef = (0, react_1.createRef)();
    const activeRef = isActiveRef && isActiveRef.current;
    (0, react_1.useEffect)(() => {
        const mouseOutCallback = (event) => {
            const target = event.target;
            if (!activeRef)
                return;
            target.classList.remove(exports.ON_HOVER);
        };
        const mouseOverCallback = (event) => {
            const target = event.target;
            if (!activeRef)
                return;
            if (selectedElement && selectedElement === target)
                return;
            if (typeof onlySelect === 'function' && (!target || !onlySelect(target))) {
                return;
            }
            else if (!onlySelect && shouldIgnoreElement(ignoreElement, elementRef, target))
                return;
            target.classList.add(exports.ON_HOVER);
        };
        const mouseClickCallback = (event) => {
            const target = event.target;
            if (!activeRef)
                return;
            if (typeof onlySelect === 'function' && (!target || !onlySelect(target))) {
                return;
            }
            else if (!onlySelect && shouldIgnoreElement(ignoreElement, elementRef, target))
                return;
            event.preventDefault();
            event.stopPropagation();
            cleanupSelected();
            target.classList.add(exports.SELECTED);
            if (onSelect)
                onSelect(target);
        };
        window.addEventListener("mouseout", mouseOutCallback, useCapture);
        window.addEventListener("mouseover", mouseOverCallback, useCapture);
        window.addEventListener("click", mouseClickCallback, useCapture);
        return () => {
            window.removeEventListener("mouseout", mouseOutCallback, useCapture);
            window.removeEventListener("mouseover", mouseOverCallback, useCapture);
            window.removeEventListener("click", mouseClickCallback, useCapture);
        };
    }, [elementRef.current, activeRef, ignoreElement, selectedElement, onlySelect]);
    (0, react_1.useEffect)(() => {
        if (activeRef) {
            const propKey = activeRef ? "add" : "remove";
            const className = tagName ? `${tagName}-active` : exports.SELECTOR_ACTIVE;
            window.document.body.classList[propKey](className);
        }
    }, [activeRef]);
    const TagName = tagName || 'element-highlight';
    return children ? (react_1.default.createElement(TagName, { ref: elementRef }, children)) : null;
};
Highlight.disposeOfElement = (element) => {
    cleanupSelected();
    if (element) {
        element.classList.remove(exports.SELECTED);
        element.classList.remove(exports.ON_HOVER);
    }
};
exports.default = Highlight;
